\documentclass[a4paper,10pt]{report}

\usepackage[utf8]{inputenc}
\usepackage{tikz}
\usepackage{xifthen}
\usetikzlibrary{calc,backgrounds,decorations,shapes,patterns}
\tikzset{
	every path/.style={line width=.5},
	every node/.style={align=center},
	>=latex,
}

% page layout
\hoffset=-1in
\voffset=-1in
\topmargin=0mm
\oddsidemargin=10mm
\textwidth=190mm
\textheight=280mm
\headheight=0mm
\pagestyle{empty}

\newcommand{\domath}[1]{\pgfmathparse{#1}\pgfresult}
\newcommand{\dd}[1]{\,\mathrm{d}#1}

% definitions of table content
\newcommand{\real}[1]{#1}
\newcommand{\virt}[1]{\overline#1}
\newcommand{\mr}{\real{M}}
\newcommand{\mv}{\virt{M}}
\newcommand{\ma}{M_a}
\newcommand{\mb}{M_b}
\newcommand{\mc}{M_c}
\newcommand{\mar}{\real{\ma}}
\newcommand{\mbr}{\real{\mb}}
\newcommand{\mcr}{\real{\mc}}
\newcommand{\mav}{\virt{\ma}}
\newcommand{\mbv}{\virt{\mb}}
\newcommand{\xc}{x_c}
\newcommand{\len}{L}
\newcommand{\load}{f}
%
\newcommand{\taa}{ $ \frac{1}{6} \len \Big[ \mar ( 2\mav + \mbv ) + $ \\ $ + \mbr ( \mav + 2\mbv ) \Big] $}
\newcommand{\tab}{ $ \frac{1}{6} \len ( 2\mar + \mbr ) \mav $ }
\newcommand{\tac}{ $ \frac{1}{6} \len ( \mar + 2\mbr ) \mbv $ }
\newcommand{\tad}{ $ \frac{1}{2} \len ( \mar +  \mbr ) \mav $ }
\newcommand{\tba}{ $ \frac{1}{6} \len \mar \Big( 2\mav + \mbv \Big) $ }
\newcommand{\tbb}{ $ \frac{1}{3} \len \mar \mav $ }
\newcommand{\tbc}{ $ \frac{1}{6} \len \mar \mbv $ }
\newcommand{\tbd}{ $ \frac{1}{2} \len \mar \mav $ }
\newcommand{\tca}{ $ \frac{1}{6} \len \mbr \Big( \mav + 2\mbv \Big) $ }
\newcommand{\tcb}{ $ \frac{1}{6} \len \mbr \mav $ }
\newcommand{\tcc}{ $ \frac{1}{3} \len \mbr \mbv $ }
\newcommand{\tcd}{ $ \frac{1}{2} \len \mbr \mav $ }
\newcommand{\tda}{ $ \frac{1}{2} \len \mar \Big( \mav + \mbv \Big) $ }
\newcommand{\tdb}{ $ \frac{1}{2} \len \mar \mav $ }
\newcommand{\tdc}{ $ \frac{1}{2} \len \mar \mbv $ }
\newcommand{\tdd}{ $ \len \mar \mav $ }
\newcommand{\tea}{ $ \frac{1}{3} \len \mcr \Big( \mav + \mbv \Big) $ }
\newcommand{\teb}{ $ \frac{1}{3} \len \mcr \mav $ }
\newcommand{\tec}{ $ \frac{1}{3} \len \mcr \mbv $ }
\newcommand{\ted}{ $ \frac{2}{3} \len \mcr \mav $ }
\newcommand{\tfa}{ $ \frac{1}{12} \len \mbr \Big( \mav + 3\mbv \Big) $ }
\newcommand{\tfb}{ $ \frac{1}{12} \len \mbr \mav $ }
\newcommand{\tfc}{ $ \frac{1}{4} \len \mbr \mbv $ }
\newcommand{\tfd}{ $ \frac{1}{3} \len \mbr \mav $ }
\newcommand{\tga}{ $ \xc \mcr \Big( \frac{21}{40} \mav + \frac{3}{5} \mbv \Big) $ } % TODO
\newcommand{\tgb}{ $ \frac{21}{40} \xc \mcr \mav $ }
\newcommand{\tgc}{ $ \frac{3}{5} \xc \mcr \mbv $ }
\newcommand{\tgd}{ $ \frac{9}{8} \xc \mcr \mav $ }
\newcommand{\tha}{ $ \frac{1}{20} \len \mbr \Big( \mav + 4\mbv \Big) $ }
\newcommand{\thb}{ $ \frac{1}{20} \len \mbr \mav $ }
\newcommand{\thc}{ $ \frac{1}{5} \len \mbr \mbv $ }
\newcommand{\thd}{ $ \frac{1}{4} \len \mbr \mav $ }
%
\newcommand{\tmcA}{ \mcr = \frac{1}{8} \load \len^2 }
\newcommand{\tmcBA}{ \mcr = \frac{\sqrt{3}}{27} \load \len^2 }
\newcommand{\tmcBB}{ \xc = \frac{\sqrt{3}}{3} \len }

\newcommand{\nodemath}[1]{$#1$}
\newcommand{\nodemathsmall}[1]{$\scriptstyle{#1}$}

% tikz aux functions
% dimension
\newcommand{\dimh}{.4} % height
\newcommand{\dimt}{.1} % dim marks size/2
\newcommand{\dimo}{.1} % offset from original point
\newcommand{\dimension}[3]{ % \dimension{coordinate1}{width}{label}
	\draw
		($#1-(0,\dimo)$) -- ++(0,{-\dimh-\dimt})
		++({-\dimt},0) -- ++({2*\dimt},{2*\dimt})
		++({-\dimt},{-\dimt}) -- ++(#2,0) node[pos=.5,above=-1] {#3}
		++({-\dimt},{-\dimt}) -- ++({2*\dimt},{2*\dimt})
		++({-\dimt},{-2*\dimt}) -- ++(0,{\dimh+\dimt});
}
% simply supported beam
\newcommand{\pinw}{.3} % pin support width
\newcommand{\pinh}{.3} % pin support height
\newcommand{\simplySupportedBeam}[2]{ % \simplySupportedBeam{coordinate1}{width}
	\draw[line width=1]
		#1 -- ++(#2,0) % beam itself
		\foreach \x in {0,#2} { ($(temp2)+(\x,0)$) -- ++({.5*\pinw},{-.5*\pinh}) -- ++({-\pinw},0) -- cycle }; % supports
}
% cantilever
\newcommand{\fixh}{.5}  % fixed support height
\newcommand{\fixw}{.13} % fixed support width
\newcommand{\fixn}{3}   % fixed support number of hatches
\newcommand{\cantilever}[2]{ % \cantilever{coordinate1}{width}
	\draw[line width=1]
		#1 -- ++(#2,0) % beam itself
		++(0,{-.5*\fixh}) -- ++(0,\fixh) % fixed support
		\foreach \i in {0,1,...,\fixn} { ($#1+(#2,{-(.5-.5/\fixn)*\fixh+\i*\fixh/(\fixn+1)})$) -- ++(\fixw,{-\fixw}) }; % fixed supported hatching
}



\begin{document}
	
	% formula
	$$
		\mathrm{HODNOTY} \ \ 
		\int_0^\len \mr\mv \dd{x}
	$$

	% table
	\begin{center}
		\begin{tikzpicture}

			% global variables
			\def\nRows{9}
			\def\nCols{5}
			\def\ddd{.05} % offset of doubled lines
			%
			\def\width{18}
			\def\height{25.5}
			\def\xs{.2, .4, .6, .8}                           % relative positions of vertical lines
			\def\ys{.09, .18, .27, .36, .45, .585, .705, .88} % relative positions of horizontal lines
			\coordinate (O) at (0,0);
			\coordinate (V) at (\width,-\height);
			%
			\def\fillcolor{black!20}
			\def\heightA{1.0} % main height of shapes (triangles, rectangles, larger height of trapezoid, cantilever parabolas)
			\def\heightB{.4}  % lesser height of trapezoids
			\def\heightP{1}   % height of parabola - simply supported beam
			\def\widthA{1.9}  % width of shapes
			\coordinate (dd) at (.8,-.3); % offset of shpes from left upper corner of the cell
			\coordinate (dd2) at ($(dd)-(0,.7)$); % second offset for simply supported beams
			\coordinate (dd3) at ($(dd)-(0,.9)$); % second offset for cantilevers
			%
			\def\fval{.5} % height of distributed load
			\coordinate (ddf) at (0,.3); % offset between moment shape and beam sketch
			%
			\def\secondOrder{\nodemath{2^\circ}}
			\def\thirdOrder{\nodemath{3^\circ}}
			%
			\def\xcval{{sqrt(3)/3.*\widthA}}

			% grid
			\draw (O) rectangle (V);
			\foreach[count=\i] \x in \xs {
				\draw ({\x*\width},0) coordinate (x\i) -- ++(0,{-\height});
				\ifthenelse{\equal{\i}{1}}{ \draw ({\x*\width-\ddd},0) -- ++(0,{-\height}); }{}
			}
			\foreach[count=\i] \y in \ys {
				\draw (0,{-\y*\height}) coordinate (y\i) -- ++(\width,0);
				\ifthenelse{\equal{\i}{1}}{ \draw (0,{-\y*\height+\ddd}) -- ++(\width,0); }{}
			}
			\path
				coordinate (x0) at (0,0)
				coordinate (x\nCols) at (\width,0)
				coordinate (y0) at (0,0)
				coordinate (y\nRows) at (0,{-\height});
			% coordinates t-i-j of grid intersections
			\path \foreach \i in {0,1,...,\nRows} { \foreach \j in {0,1,...,\nCols} { coordinate (t-\i-\j) at (x\j |- y\i) } };
			\draw (t-0-0) -- ($(t-1-1)+({-\ddd},\ddd)$)
				node at ($1/3.*(t-0-0)+1/3.*(t-0-1)+1/3.*(t-1-1)$) {$\mv$}
				node at ($1/3.*(t-0-0)+1/3.*(t-1-0)+1/3.*(t-1-1)$) {$\mr$}
				;
			\node[below right] at (t-9-0) {Jan Stránský, ver. 2013/04/17};

			% table content
			\node at ($.5*(t-1-1)+.5*(t-2-2)$) {\taa};
			\node at ($.5*(t-1-2)+.5*(t-2-3)$) {\tab};
			\node at ($.5*(t-1-3)+.5*(t-2-4)$) {\tac};
			\node at ($.5*(t-1-4)+.5*(t-2-5)$) {\tad};
			\node at ($.5*(t-2-1)+.5*(t-3-2)$) {\tba};
			\node at ($.5*(t-2-2)+.5*(t-3-3)$) {\tbb};
			\node at ($.5*(t-2-3)+.5*(t-3-4)$) {\tbc};
			\node at ($.5*(t-2-4)+.5*(t-3-5)$) {\tbd};
			\node at ($.5*(t-3-1)+.5*(t-4-2)$) {\tca};
			\node at ($.5*(t-3-2)+.5*(t-4-3)$) {\tcb};
			\node at ($.5*(t-3-3)+.5*(t-4-4)$) {\tcc};
			\node at ($.5*(t-3-4)+.5*(t-4-5)$) {\tcd};
			\node at ($.5*(t-4-1)+.5*(t-5-2)$) {\tda};
			\node at ($.5*(t-4-2)+.5*(t-5-3)$) {\tdb};
			\node at ($.5*(t-4-3)+.5*(t-5-4)$) {\tdc};
			\node at ($.5*(t-4-4)+.5*(t-5-5)$) {\tdd};
			\node at ($.5*(t-5-1)+.5*(t-6-2)$) {\tea};
			\node at ($.5*(t-5-2)+.5*(t-6-3)$) {\teb};
			\node at ($.5*(t-5-3)+.5*(t-6-4)$) {\tec};
			\node at ($.5*(t-5-4)+.5*(t-6-5)$) {\ted};
			\node at ($.5*(t-6-1)+.5*(t-7-2)$) {\tfa};
			\node at ($.5*(t-6-2)+.5*(t-7-3)$) {\tfb};
			\node at ($.5*(t-6-3)+.5*(t-7-4)$) {\tfc};
			\node at ($.5*(t-6-4)+.5*(t-7-5)$) {\tfd};
			\node at ($.5*(t-7-1)+.5*(t-8-2)$) {\tga};
			\node at ($.5*(t-7-2)+.5*(t-8-3)$) {\tgb};
			\node at ($.5*(t-7-3)+.5*(t-8-4)$) {\tgc};
			\node at ($.5*(t-7-4)+.5*(t-8-5)$) {\tgd};
			\node at ($.5*(t-8-1)+.5*(t-9-2)$) {\tha};
			\node at ($.5*(t-8-2)+.5*(t-9-3)$) {\thb};
			\node at ($.5*(t-8-3)+.5*(t-9-4)$) {\thc};
			\node at ($.5*(t-8-4)+.5*(t-9-5)$) {\thd};

			% sketches labels
			\def\nlen{\nodemath{\len}}
			\def\nlenHalf{\nodemath{\len/2}}
			\def\nmav{\nodemath{\mav}}
			\def\nmbv{\nodemath{\mbv}}
			\def\nmar{\nodemath{\mar}}
			\def\nmbr{\nodemath{\mbr}}
			\def\nmcr{\nodemath{\mcr}}
			\def\nload{\nodemath{\load}}
			\def\nxc{\nodemath{\xc}}
			\def\ntmcA{\nodemath{\tmcA}}
			\def\ntmcB{\nodemath{\tmcBA} \\ \nodemath{\tmcBB}}

			% sketch t0a trapezoid
			\coordinate (temp) at ($(t-0-1) + (dd)$);
			\draw[fill=\fillcolor] (temp) -- ++(0,{-\heightA}) coordinate (temp2) node[pos=.5,left] {\nmav} -- ++(\widthA,{\heightA-\heightB}) -- ++(0,\heightB) node[pos=.5,right] {\nmbv} -- cycle;
			\dimension{(temp2)}{\widthA}{\nlen}

			% sketch t0b triangle
			\coordinate (temp) at ($(t-0-2) + (dd)$);
			\draw[fill=\fillcolor] (temp) -- ++(0,{-\heightA}) coordinate (temp2) node[pos=.5,left] {\nmav} -- ++(\widthA,\heightA) -- cycle;
			\dimension{(temp2)}{\widthA}{\nlen}

			% sketch t0c triangle
			\coordinate (temp) at ($(t-0-3) + (dd)$);
			\draw[fill=\fillcolor] (temp) -- ++(\widthA,{-\heightA}) -- ++(0,\heightA) node[pos=.5,right] {\nmbv} -- cycle;
			\coordinate (temp2) at ($(temp)-(0,\heightA)$);
			\dimension{(temp2)}{\widthA}{\nlen}

			% sketch t0d rectangle
			\coordinate (temp) at ($(t-0-4) + (dd)$);
			\draw[fill=\fillcolor] (temp) -- ++(0,{-\heightA}) coordinate (temp2) node[pos=.5,left] {\nmav} -- ++(\widthA,0) -- ++(0,\heightA) -- cycle;
			\dimension{(temp2)}{\widthA}{\nlen}

			% sketch ta0 trapezoid
			\coordinate (temp) at ($(t-1-0) + (dd)$);
			\draw[fill=\fillcolor] (temp) -- ++(0,{-\heightA}) coordinate (temp2) node[pos=.5,left] {\nmar} -- ++(\widthA,{\heightA-\heightB}) -- ++(0,\heightB) node[pos=.5,right] {\nmbr} -- cycle;
			\dimension{(temp2)}{\widthA}{\nlen}

			% sketch tb0 triangle
			\coordinate (temp) at ($(t-2-0) + (dd)$);
			\draw[fill=\fillcolor] (temp) -- ++(0,{-\heightA}) coordinate (temp2) node[pos=.5,left] {\nmar} -- ++(\widthA,\heightA) -- cycle;
			\dimension{(temp2)}{\widthA}{\nlen}

			% sketch tc0 triangle
			\coordinate (temp) at ($(t-3-0) + (dd)$);
			\draw[fill=\fillcolor] (temp) -- ++(\widthA,{-\heightA}) -- ++(0,\heightA) node[pos=.5,right] {\nmbr} -- cycle;
			\coordinate (temp2) at ($(temp)-(0,\heightA)$);
			\dimension{(temp2)}{\widthA}{\nlen}

			% sketch td0 rectangle
			\coordinate (temp) at ($(t-4-0) + (dd)$);
			\draw[fill=\fillcolor] (temp) -- ++(0,{-\heightA}) coordinate (temp2) node[pos=.5,left] {\nmar} -- ++(\widthA,0) -- ++(0,\heightA) -- cycle;
			\dimension{(temp2)}{\widthA}{\nlen}

			% sketch te0 simply supported beam 1
			\coordinate (temp) at ($(t-5-0) + (dd2)$);
			\draw[fill=\fillcolor] (temp) node[below=7] {\secondOrder} parabola[parabola height={-\heightP*1cm/1pt}] ++(\widthA,0) -- cycle; % parabola
			\draw[<->] ($(temp)+({.5*\widthA},{-\heightP})$) -- ++(0,\heightP) node[pos=.7,right] {\nmcr}; % moment dimension
			\dimension{($(temp)-(0,\heightP)$)}{{.5*\widthA}}{\nlenHalf}
			\dimension{($(temp)-({-.5*\widthA},\heightP)$)}{{.5*\widthA}}{\nlenHalf}
			\node[above right] at (t-6-0) {\ntmcA}; % m = 1/8*fL^2
			% beam sketch
			\coordinate (temp2) at ($(temp)+(ddf)$);
			\draw (temp2) rectangle ++(\widthA,\fval) node[below right] {\nload}; % load rectangle
			\foreach \x in {.1,.2,...,.91} { \draw[<-] ($(temp2)+({\x*\widthA},0)$) -- ++(0,\fval); } % load arrows
			\simplySupportedBeam{(temp2)}{\widthA}

			% sketch tf0 cantilever 1
			\coordinate (temp) at ($(t-6-0) + (dd3)$);
			\draw[fill=\fillcolor] (temp) node[below] {\secondOrder} parabola ++(\widthA,{-\heightA}) -- ++(0,\heightA) node[pos=.5,right] {\nmbr} -- cycle; % parabola
			\dimension{($(temp)-(0,\heightA)$)}{\widthA}{\nlen}
			% beam sketch
			\coordinate (temp2) at ($(temp)+(ddf)$);
			\draw
				coordinate (temp3) at ($(temp2)+(0,\fval)$)
				(temp3) rectangle ++(\widthA,{-\fval}) node[right] {\nload}; % load rectangle
			\foreach \x in {.1,.2,...,.91} { \draw[->] ($(temp2)+({\x*\widthA},0)$) -- ++(0,\fval); } % load arrows
			\cantilever{(temp3)}{\widthA}


			% sketch tg0 simply supported beam 2
			\coordinate (temp) at ($(t-7-0) + (dd2)$);
			\coordinate (temp2) at ($(temp)+(\xcval,{-\heightP})$);
			\draw[fill=\fillcolor] (temp) parabola[bend at end] (temp2) parabola ($(temp)+(\widthA,0)$) node[below=10] {\thirdOrder} -- cycle; % parabola
			\draw[<->] (temp2) -- ++(0,\heightP) node[pos=.6,left] {\nmcr}; % moment dimension
			\dimension{($(temp)-(0,\heightP)$)}{\xcval}{\nxc}
			\dimension{($(temp)-(0,{\heightP+\dimh+.2})$)}{\widthA}{\nlen}
			\node[above right,align=left] at (t-8-0) {\ntmcB}; % moment value
			% beam sketch
			\coordinate (temp2) at ($(temp)+(ddf)$);
			\draw[line join=bevel] (temp2) -- ++(\widthA,0) -- ++ (0,\fval) node[below right] {\nload} -- cycle; % load triangle
			\foreach \x in {.3,.4,...,.91} { \draw[<-] ($(temp2)+({\x*\widthA},0)$) -- ++(0,{\x*\fval}); } % load arrows
			\simplySupportedBeam{(temp2)}{\widthA}

			% sketch th0 cantilever 2
			\coordinate (temp) at ($(t-8-0) + (dd3)$);
			\draw[fill=\fillcolor] (temp) node[below] {\thirdOrder} parabola ++(\widthA,{-\heightA}) -- ++(0,\heightA) node[pos=.5,right] {\nmbr} -- cycle;
			\dimension{($(temp)-(0,\heightA)$)}{\widthA}{\nlen}
			% beam sketch
			\coordinate (temp2) at ($(temp)+(ddf)$);
			\draw[line join=bevel]
				coordinate (temp3) at ($(temp2)+(0,\fval)$)
				(temp3) -- ++(\widthA,{-\fval}) node[right] {\nload} -- ++(0,\fval) -- cycle; % load triangle
			\foreach \x in {.3,.4,...,.91} { \draw[<-] ($(temp3)+({\x*\widthA},0)$) -- ++(0,{-\x*\fval}); } % load arrows
			\cantilever{(temp3)}{\widthA}

		\end{tikzpicture}
	\end{center}
\end{document}
